#! /bin/bash

RED_COLOR="\E[31m"
GREEN_COLOR="\E[32m"
RESET_COLOR="\E[37m"

FOLDERS=( "experiments/trunc" "experiments/cut" "experiments/glue" "experiments/rnd01_cube" "experiments/dwarfcube" "experiments/metric" "experiments/cyclic" ) # 
TIMEOUT=( 3600 3600 1800 3600 1000 3600 3600 ) # 

for (( i = 0; i < ${#FOLDERS[@]}; i++ )); do
    echo -n "Checking folder ${FOLDERS[${i}]}..."
    if [ -d ${FOLDERS[${i}]} ]; then
        echo -e "${GREEN_COLOR}`ls ${FOLDERS[${i}]}/* | egrep '\.ine$|\.ext$' | wc -l` files.${RESET_COLOR}"
    else
        echo -e "${RED_COLOR}no such folder!${RESET_COLOR}"
    fi
done 

for (( i = 0; i < ${#FOLDERS[@]}; i++ )); do
   ./benchmark.sh ${FOLDERS[${i}]} bin ${TIMEOUT[${i}]}
done 
