/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_ABSTRACT_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__
#define __DD_ABSTRACT_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__

#include "DDSingleBitSplitVisitor.h"
#include "DDAbstractFragmentationSplitVisitor.h"

namespace addibit {

    class AbstractFragmentedSingleBitSplitVisitor : public SingleBitSplitVisitor, virtual public AbstractFragmentationSplitVisitor {

        protected:        
        void registerContainer ( const unsigned int id ) {
            SingleBitSplitVisitor::registerContainer( id );
        }
        
        unsigned int getTargetContainer ( const RayReference & ref ) {
            const unsigned int c_index = SingleBitSplitVisitor::getTargetContainer( ref );
            registerReference( ref, set( c_index ).id() );
            return c_index;
        }        

        public:
        AbstractFragmentedSingleBitSplitVisitor ( const unsigned int depth,
                                                  const unsigned int capacity,
                                                  const BitSelectStrategy & strategy,
                                                  const unsigned int fsize ) :
            BitSplitVisitor( depth, capacity, 2 ),
            AbstractFragmentationSplitVisitor( depth, capacity, fsize ),
            SingleBitSplitVisitor( depth, capacity, strategy ) {}         
            
        void before ( const RayReferenceContainer & current ) {
            SingleBitSplitVisitor::before( current );
        }

        void after () {
            SingleBitSplitVisitor::after();
        }                        
        
        bool can_proceed ( const unsigned int index ) const {
            return SingleBitSplitVisitor::can_proceed( index );
        }                             
    };
}

#endif /* __DD_ABSTRACT_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__ */
