/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDAbstractIntermediateTreeNode.h"

using namespace addibit;

void AbstractIntermediateTreeNode::insert ( const TreeNode * const child  ) {
    insert( mChildrenCount++, child );
} 

void AbstractIntermediateTreeNode::insert ( const uint_fast16_t index,
                                            const TreeNode * const child  ) {

    if ( likely( index < __MIN_TREE_CHILD_NODES__ ) ) {
        mChildBase[ index ] = child;
    } else {
        mChild.push_back( child );  
    //    mChild[ index - __MIN_TREE_CHILD_NODES__ ] = child;
    }
}   

uint_fast64_t AbstractIntermediateTreeNode::getRaysCount () const {
    uint_fast64_t count = 0;

    /*for ( uint_fast16_t index = 0; index < mChildrenCount; index++ ) {
        count += child( index )->getRaysCount();
    }  @FIXME */
    return count;
}

uint_fast32_t AbstractIntermediateTreeNode::getSubNodesCount () const {
    uint_fast32_t count = mChildrenCount;

   /* for ( uint_fast16_t index = 0; index < mChildrenCount; index++ ) {
        count += child( index )->getSubNodesCount();
    } @FIXME */
    return count;
}

const std::string AbstractIntermediateTreeNode::toGraphVizString ( const uint_fast16_t depth ) const {
    std::stringstream result;

    const TreeNode * node = this;

    result << "p" << static_cast<const void*>( node ) << " [shape=rectangle,label=\"" << toString() << "\"];\n";

    if ( depth > 0 ) {
        for ( uint_fast16_t i = 0; i < mChildrenCount; i++ ) {
            result << child( i )->toGraphVizString( depth - 1 )
                   << "p" << static_cast<const void*>( node ) << "->" << "p" << static_cast<const void*>( child( i ) ) << ";\n";
        }
    }

    return result.str();
}
