/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_ADJACENCY_CANDIDATE__
#define __DD_ADJACENCY_CANDIDATE__

#include "DDBitList.h"

namespace addibit {

    class AdjacencyCandidate {
        
        private:
        uintptr_t mId;
        uint_fast16_t mPopCount;
        
        __BIT_LIST_RAW_DATA_TYPE__ __data[1];
        
        public:
        
        inline static uint_fast32_t dynamic_size () {
            return sizeof( AdjacencyCandidate ) + sizeof( __BIT_LIST_RAW_DATA_TYPE__ ) * ( __DD_BLOCK_COUNT__ - 1 );
        }
        
        inline uintptr_t id () const {
            return mId;
        }
        
        inline void set_id ( const uintptr_t id ) {
            mId = id;
        }
            
        inline const __BIT_LIST_RAW_DATA_TYPE__ * data () const {
            return __data;
        }
        
        inline const __BIT_LIST_RAW_DATA_TYPE__ * aux_data () const {
            return __data + __DD_BLOCK_COUNT__;
        }
        
        inline __BIT_LIST_RAW_DATA_TYPE__ * aux_data () {
            return __data + __DD_BLOCK_COUNT__;
        }
        
        inline void cut_and_save ( const __BIT_LIST_RAW_DATA_TYPE__ * const arg_1, const __BIT_LIST_RAW_DATA_TYPE__ * const arg_2 ) {
            mPopCount = BitList::_op_cut_and_save( __data, arg_1, arg_2 );
        }
        
        inline uint_fast16_t population () const {
            return mPopCount;
        }
        
        inline void set_population ( const uint_fast16_t pop_cnt ) {
            mPopCount = pop_cnt;
        }
    };
}
#endif /* __DD_ADJACENCY_CANDIDATE__ */
