/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_ALG_TEST_SINGLE_SET_RAY_ENUMERATOR__
#define __DD_ALG_TEST_SINGLE_SET_RAY_ENUMERATOR__

#include "DDExtremeRayEnumerator.h"
#include "DDAlgTestTraverseVisitor.h"
#include "DDAlgTestSingleSetRayCacheEntry.h"

#define __DD_ALG_TEST_SINGLE_SET_RAY_ENUMERATOR_CONTAINERS__ 4

namespace addibit {
    
    class AlgTestSingleSetRayEnumerator : public ExtremeRayEnumerator<SingleSetRay, AlgTestSingleSetRayCacheEntry, PositiveAlgTestTraverseVisitor, NegativeAlgTestTraverseVisitor> {
    
        protected:
        inline PositiveAlgTestTraverseVisitor positive_traverse_visitor ( const TreeNode * const tree,
                                                                          const RayWrapperContainer<SingleSetRay> & container,
                                                                          const uint_fast16_t stack_size ) const {
            return PositiveAlgTestTraverseVisitor( tree, container, stack_size, mPlane, mSystem, mCacheNode );
        }
        
        inline NegativeAlgTestTraverseVisitor negative_traverse_visitor ( const TreeNode * const tree,
                                                                          const RayWrapperContainer<SingleSetRay> & container,
                                                                          const uint_fast16_t stack_size ) const {
            return NegativeAlgTestTraverseVisitor( tree, container, stack_size, mPlane, mSystem, mCacheNode );
        }
      
        public:
        AlgTestSingleSetRayEnumerator ( const Matrix & system,
                                        const uint_fast16_t plane,
                                        CacheEntryNode<SingleSetRay, AlgTestSingleSetRayCacheEntry> * node ) :
            ExtremeRayEnumerator<SingleSetRay, AlgTestSingleSetRayCacheEntry, PositiveAlgTestTraverseVisitor, NegativeAlgTestTraverseVisitor>( system, plane, node, __DD_ALG_TEST_SINGLE_SET_RAY_ENUMERATOR_CONTAINERS__ ) {}  
    };
}

#endif /* __DD_ALG_TEST_SINGLE_SET_RAY_ENUMERATOR__ */
