/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_ALG_TEST_SINGLE_SET_RAY_GENERATOR__
#define __DD_ALG_TEST_SINGLE_SET_RAY_GENERATOR__

#include "DDSingleSetRayGenerator.h"
#include "DDAlgTestSingleSetRayCacheEntry.h"

namespace addibit {

	class AlgTestSingleSetRayGenerator : public SingleSetRayGenerator<AlgTestSingleSetRayCacheEntry> {

        protected:
		const struct StepStats enumerate ( const unsigned long plane, CacheEntryNode<SingleSetRay, AlgTestSingleSetRayCacheEntry> * node );

        void fork ( CacheEntryNode<SingleSetRay, AlgTestSingleSetRayCacheEntry> * const node ) {
            t_fork<AlgTestSingleSetRayGenerator>( node );
        }

		public:
		AlgTestSingleSetRayGenerator ( const Matrix & system ) :
            SingleSetRayGenerator<AlgTestSingleSetRayCacheEntry> ( system ) {}
            
		AlgTestSingleSetRayGenerator ( const Matrix & system,
		                               CacheEntryNode<SingleSetRay, AlgTestSingleSetRayCacheEntry> * const node ) :
            SingleSetRayGenerator<AlgTestSingleSetRayCacheEntry> ( system, node ) {} 
            
        ~AlgTestSingleSetRayGenerator () {}
	};
}

#endif // __DD_ALG_TEST_SINGLE_SET_RAY_GENERATOR__
