/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_BINARY_FRAGMENTATION_SPLIT_VISITOR__
#define __DD_BINARY_FRAGMENTATION_SPLIT_VISITOR__

#include "DDBitSplitVisitor.h"
#include "DDRayRefBinaryFragmentationMapping.h"
#include "DDContainerBinaryFragmentationMapping.h"
#include "DDContainerBitPatternMapping.h"

namespace addibit {

    class BinaryFragmentationSplitVisitor : virtual public BitSplitVisitor {
    
        protected:
        ContainerBinaryFragmentationMapping mFragmentationMapping;
        ContainerBitPatternMapping mBitPatternMapping;
             
        RayRefBinaryFragmentationMapping mRefMapping;
        
        void registerContainer ( const unsigned int ) {
            mFragmentationMapping.insert_empty();
            mBitPatternMapping.insert_empty();
        }
        
        void registerReference ( const struct RayReference & ref,
                                 const unsigned int containerId ) {
            
            const BitList & map = mRefMapping[ ref.id ];
            mFragmentationMapping.update( containerId, map );
            mBitPatternMapping.update( containerId, ref.activeSet );
        }      
        
        public:
        BinaryFragmentationSplitVisitor ( const unsigned int depth,
                                          const unsigned int capacity,
                                          const unsigned int fsize,
                                          const unsigned int blocks ) :
            BitSplitVisitor( depth, capacity, fsize + 1 ),
            mFragmentationMapping( blocks ),
            mRefMapping( blocks ) {}                                          
        
        void init ( const RayReferenceContainer & container ) {
            mBitPatternMapping.reset();
        
            BitSplitVisitor::init( container );
            
            mRefMapping.init( container.size() );
            container.iterate( mRefMapping );    
        }
                
        void refineCondition ( const uint_fast32_t /* index */,
                               TwoBitsFragmentationCondition & /* cond */ ) const {                                                            
                               
        /*    const unsigned int container_id = set( index ).id();
            const BitList & map = mBitPatternMapping.union_map( container_id );  */
            
            //@ToDo Check whether this file is still needed            
        }                                       
    };
}

#endif /* __DD_BINARY_FRAGMENTATION_SPLIT_VISITOR__ */
