/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_BINARY_STATIC_VANTAGE_POINT_STATIC_DIST_VISITOR__
#define __DD_BINARY_STATIC_VANTAGE_POINT_STATIC_DIST__VISITOR__

#include "DDBinaryStaticVantagePointVisitor.h"

namespace addibit {

    class BinaryStaticVantagePointStaticDistVisitor : public BinaryStaticVantagePointVisitor {

        private:
        const unsigned int mDistance;

        protected:
        bool subset_condition ( const RayReference & ref ) const {
            return mVantagePoint.getCommonPopCnt( ref.activeSet ) < mDistance; 
        }

        bool can_proceed ( const unsigned int ) const {
            return false;
        }

        public:
        BinaryStaticVantagePointStaticDistVisitor ( const unsigned int depth,
                                                    const unsigned int capacity,
                                                    const BitList & point,
                                                    const unsigned int distance ) :
            BinaryStaticVantagePointVisitor( depth, capacity, point ),
            mDistance( distance ) {}
    };
}

#endif // __DD_BINARY_STATIC_VANTAGE_POINT_STATIC_DIST__VISITOR__
