
#include "DDBitSetTreeNode.h"

using namespace addibit;

void BitSetTreeNode::partition ( const unsigned int threshold ) {

	if ( mRays.size() > threshold ) {
		const BitList candidates = mMap & mUnpartitionedBits;
		const unsigned long partition_bit = candidates.getFirstSet();

		unpartitioned.unset( partition_bit );

		mSuperSet = new BitSetTreeNode( unpartitioned );
		mSubSet = new BitSetTreeNode( unpartitioned );
		
		for ( unsigned int index = 0; index < mRays.size(); index++ ) {
			if ( mRays[index]->isSet( partition_bit ) ) {
				mSuperSet->insert( mRays[index] );
			} else {
				mSubSet->insert( mRays[index] );
			}
		}

		mRays.clear();

		mSuperSet->partition( threshold );
		mSubSet->partition( threshold );
	}
}
