/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDCombTestSingleSetRayEnumerator.h"
#include "DDCombTestTraverseVisitor.h"

using namespace addibit;

#ifdef __STATS_OUTPUT__
void CombTestSingleSetRayEnumerator::fill_stats ( struct StepStats & stats ) {

    ExtremeRayEnumerator<SingleSetRay, CombTestSingleSetRayCacheEntry, PositiveCombTestTraverseVisitor, NegativeCombTestTraverseVisitor>::fill_stats( stats );
    
    stats.verification_ops_actual = TreeNodeCondition::VERIFICATION_OPS;
    stats.nontrivial_candidates = TreeNodeCondition::NONTRIVIAL_CANDIDATES;
    stats.verification_ops_linear = stats.nontrivial_candidates * pow( mCacheNode.data().verification_ld().size() + mCacheNode.data().verification_hd().size(), 0.66666666667 );
    stats.verification_ops_logarithmic = stats.nontrivial_candidates * log2( mCacheNode.data().verification_ld().size() + mCacheNode.data().verification_hd().size());
    
    if ( stats.verification_ops_actual > stats.verification_ops_logarithmic ) {
        stats.verification_complexity = ( stats.verification_ops_actual - stats.verification_ops_logarithmic ) / ( stats.verification_ops_linear - stats.verification_ops_logarithmic ) + 1;
    } else {
        stats.verification_complexity = 1;
    } 
}
#endif
