/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_COMB_TEST_SINGLE_SET_RAY_GENERATOR__
#define __DD_COMB_TEST_SINGLE_SET_RAY_GENERATOR__

#include "DDSingleSetRayGenerator.h"
#include "DDCombTestSingleSetRayCacheEntry.h"

namespace addibit {

	class CombTestSingleSetRayGenerator : public SingleSetRayGenerator<CombTestSingleSetRayCacheEntry> {

        protected:
		const struct StepStats enumerate ( const uint_fast16_t plane, CacheEntryNode<SingleSetRay, CombTestSingleSetRayCacheEntry> * node );

        void fork ( CacheEntryNode<SingleSetRay, CombTestSingleSetRayCacheEntry> * const node ) {
            t_fork<CombTestSingleSetRayGenerator>( node );
        }

		public:
		CombTestSingleSetRayGenerator ( const Matrix & system ) :
            SingleSetRayGenerator<CombTestSingleSetRayCacheEntry> ( system ) {}
            
		CombTestSingleSetRayGenerator ( const Matrix & system,
		                                CacheEntryNode<SingleSetRay, CombTestSingleSetRayCacheEntry> * const node ) :
            SingleSetRayGenerator<CombTestSingleSetRayCacheEntry> ( system, node ) {} 
      
        ~CombTestSingleSetRayGenerator () {}
	};
}

#endif // __DD_COMB_TEST_SINGLE_SET_RAY_GENERATOR__
