/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDConditionedRayReferenceContainerList.h"

using namespace addibit;

const std::string ConditionedRayReferenceContainerList::toString () const {
    std::stringstream result;
    std::string label = "phead";
    
    result << "phead [shape=rectangle,label=\"Head\"];\n";
    
    for ( std::vector<AbstractConditionedRayReferenceContainer const * >::const_iterator it_container = mElements.begin(); it_container != mElements.end(); it_container++ ) {
        result << (*it_container)->toString();
        result << label << "->" << "p" << static_cast<const void*>( *it_container ) << ";\n";
        
        std::stringstream label_stream;
        label_stream << "p" << static_cast<const void*>( *it_container );
        label = label_stream.str();
    }     

    return result.str(); 
}
