/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDConstants.h"

namespace addibit {
    uint_fast16_t GLOBAL_BLOCKS = 0;
    uint_fast16_t GLOBAL_EDGE_DIM = 0;
    uint_fast16_t GLOBAL_RAY_DIM = 0;
    uint_fast16_t GLOBAL_RAY_MIN_FACETS = 0;
    uint_fast16_t GLOBAL_MATRIX_ROWS = 0;

    void init_constants ( const uint_fast16_t blocks, const uint_fast16_t edge_dim, const uint_fast16_t rows ) {
        GLOBAL_BLOCKS = blocks;
        GLOBAL_EDGE_DIM = edge_dim;
        GLOBAL_RAY_DIM = edge_dim + 2;
        GLOBAL_RAY_MIN_FACETS = edge_dim + 1;
        GLOBAL_MATRIX_ROWS = rows;
    }
}
