/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_CONSTANTS__
#define __DD_CONSTANTS__

#include <stdint.h>

namespace addibit {
    extern uint_fast16_t GLOBAL_BLOCKS;
    extern uint_fast16_t GLOBAL_EDGE_DIM;
    extern uint_fast16_t GLOBAL_MATRIX_ROWS;
    extern uint_fast16_t GLOBAL_RAY_DIM;
    extern uint_fast16_t GLOBAL_RAY_MIN_FACETS;
    
    extern void init_constants  ( const uint_fast16_t blocks, const uint_fast16_t edge_dim, const uint_fast16_t rows );
}

#ifndef __DD_BLOCK_COUNT__ 
#define  __DD_BLOCK_COUNT__ GLOBAL_BLOCKS
#endif /* __DD_BLOCK_COUNT__ */

#ifndef __DD_EDGE_DIM__
    #define __DD_EDGE_DIM__ GLOBAL_EDGE_DIM
#endif

#endif /* __DD_CONSTANTS__ */
