/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_CONTAINER_POPULATION_MAPPING__
#define __DD_CONTAINER_POPULATION_MAPPING__

#include <vector>

#include "DDInterval.h"

namespace addibit {

    class ContainerPopulationMapping {
    
        private:
        std::vector<Interval> mBounds;
        
        public:
        ContainerPopulationMapping () {}
        ~ContainerPopulationMapping () {}
        
        const Interval & operator[] ( const unsigned int id ) const {
            return mBounds[ id ];
        }
        
        void insert_empty () {
            mBounds.push_back( Interval() );
        }        
        
        void update ( const unsigned int id, const unsigned int value ) {
           mBounds[ id ].update( value );
        }
        
        void reset () {
            mBounds.clear();
        }        
    };
}

#endif /* __DD_CONTAINER_POPULATION_MAPPING__ */
