
#ifndef __DD_DOUBLE_VANTAGE_POINT_PRELIMINARY_CONDITION__
#define __DD_DOUBLE_VANTAGE_POINT_PRELIMINARY_CONDITION__

#include "DDTreeNodeCondition.h"

namespace addibit {

	class DoubleVantagePointTreeNodeCondition : public VantagePointTreeNodeCondition {

        protected:
        const unsigned int mMinInvDistance;

		public:
		DoubleVantagePointTreeNodeCondition ( const BitList & map,
										         const unsigned int minCommonBits,
										         const BitList & point,
                                                 const unsigned int distance,
                                                 const unsigned int inverse ) :
            MapCondition( map ),
			VantagePointTreeNodeCondition( map, minCommonBits, point, distance ),
            mMinInvDistance( inverse ) {}

        bool holdsOnFace ( const BitList & activeSetUnion ) const {
            const unsigned int union_dist = mVantagePoint.getCommonPopCnt( activeSetUnion ) + 1;
            const unsigned int union_inv_dist = mVantagePoint.getInvCommonPopCnt( activeSetUnion ) + 1;
            return std::min( union_dist, mMinDistance ) + std::min( union_inv_dist, mMinInvDistance ) >= getMinCommonBits() + 2;
        }

        const std::string toString () const {
            std::stringstream result;

            result << "~d=" << mMinInvDistance;

            return VantagePointTreeNodeCondition::toString() + ", " + result.str();            
        }
	};
}

#endif // __DD_DOUBLE_VANTAGE_POINT_PRELIMINARY_CONDITION__
