/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__
#define __DD_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__

#include "DDAbstractFragmentedSingleBitSplitVisitor.h"
#include "DDFragmentationSplitVisitor.h"

namespace addibit {

    class FragmentedSingleBitSplitVisitor : public AbstractFragmentedSingleBitSplitVisitor, public FragmentationSplitVisitor {    

        public:
        FragmentedSingleBitSplitVisitor ( const unsigned int depth,
                                          const unsigned int capacity,
                                          const BitSelectStrategy & strategy,
                                          const unsigned int fsize,
                                          const unsigned int fcount,
                                          const unsigned int blocks ) :
            BitSplitVisitor( depth, capacity, 2 ),
            AbstractFragmentationSplitVisitor( depth, capacity, fsize ),
            AbstractFragmentedSingleBitSplitVisitor( depth, capacity, strategy, fsize ),
            FragmentationSplitVisitor( depth, capacity, fsize, fcount, blocks ) {}    
            
        void init ( const RayReferenceContainer & container ) {
            FragmentationSplitVisitor::init( container );    
        }               
                 
        void refineCondition ( const uint_fast32_t index,
                               TwoBitsFragmentationCondition & cond ) const {

            
        }                             
    };
}

#endif /* __DD_FRAGMENTED_SINGLE_BIT_SPLIT_VISITOR__ */
