/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "DDLinearDependenceCache.h"
#include <sstream>
#include <iostream>

using namespace addibit;

LinearDependenceCache::LinearDependenceCache ( const Matrix & system ) :
	mSystem( system ),
	mSolver( system.getColumns(), system.getRows() ),
	mLoaded( false ) {

	for ( unsigned long index = system.getColumns(); index < system.getRows(); index++ ) {
		data.push_back( LinearDependenceVector( index, BitList::getBlocks( system.getRows() ) ) );
	} 
}

unsigned long LinearDependenceCache::getSize() const {
	unsigned long size = 0;	

	for ( unsigned long i = 0; i < data.size(); i++ ) {
		size += data[i].getSize();
	}

	return size;
}

const std::string LinearDependenceCache::toString () const {
	std::stringstream output;

	for ( unsigned long i = 0; i < data.size(); i++ ) {
		output << "Cell " << i << ":" << data[i].toString() << std::endl;
	}

	return output.str();
}
