/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "DDLogging.h"

#include <fstream>

namespace addibit {
    std::map<std::string, std::stringstream*> loggers = std::map<std::string, std::stringstream*>();
    std::mutex output_mutex;
    std::mutex plot_mutex;
    
#ifdef __STATS_OUTPUT__    
    void DUMP_STRING ( const char * file, const std::string & value ) {
        std::fstream output( file, std::fstream::out );        

        output << value;
        output.close();        
    }
#else
    void DUMP_STRING ( const char * , const std::string & ) {}
#endif  /* __STATS_OUTPUT__ */   

    void init_logging () {
        std::cout.precision( 2 );
    }
}
