
#ifndef __DD_MOST_COMMON_FIRST_DYNAMIC_SAMPLE_CREATOR__
#define __DD_MOST_COMMON_FIRST_DYNAMIC_SAMPLE_CREATOR__

#include <vector>
#include <algorithm>

#include "DDDynamicSampleCreator.h"

namespace addibit {

    struct MostCommonFirstComparator {

        bool operator () ( const struct PopulationEntry & lhs, const struct PopulationEntry & rhs ) const {
            return lhs.count > rhs.count;
        }
    };

    class MostCommonFirstDynamicSampleCreator : public DynamicSampleCreator {

        public:
        MostCommonFirstDynamicSampleCreator( const unsigned int blocks,
                                             const unsigned int minCommonBits,
                                             const float intensityFactor,
                                             const float sampleDifference,
                                             const float stretch ) :
            DynamicSampleCreator( blocks, minCommonBits, intensityFactor, sampleDifference, stretch ) {}   

            void reorder ( std::vector<struct PopulationEntry> & stats ) const {
                struct MostCommonFirstComparator comparator;
                sort( stats.begin(), stats.end(), comparator );
            }
    };
}

#endif // __DD_MOST_COMMON_FIRST_DYNAMIC_SAMPLE_CREATOR__
