
#ifndef __DD_POP_CNT_SPLIT_VISITOR__
#define __DD_POP_CNT_SPLIT_VISITOR__

#include "DDBitSplitVisitor.h"

namespace addibit {

    enum PopCntSplitVisitorSets {
        POP_CNT_SPLIT_LOW   = 0,
        POP_CNT_SPLIT_HIGH  = 1
    }; 

    class PopCntSplitVisitor : public BitSplitVisitor {       

        private:
        unsigned int mMedian;

        public:
        PopCntSplitVisitor( const unsigned int depth, const unsigned int capacity ) :
            BitSplitVisitor( depth, capacity, 2 ),
            mMedian( 0 ) {}

        void setMedian( const unsigned int median ) {
            mMedian = median;
        }

        void onVisit ( const struct RayReference & ref ) {

		    if ( ref.degeneracy > mMedian ) {
			    set( POP_CNT_SPLIT_HIGH ).insert( ref );
		    } else {
			    set( POP_CNT_SPLIT_LOW ).insert( ref );
		    }
        }

        void onFinish () {}    


        bool hasFinished () const {
            return true;
        } 
    };
}

#endif // __DD_POP_CNT_SPLIT_VISITOR__
