
#ifndef __DD_POP_TREE_PRELIMINARY_CONDITION__
#define __DD_POP_TREE_PRELIMINARY_CONDITION__

#include "DDBitList.h"
#include "DDMapCondition.h"
#include "DDPopTreeMapCondition.h"
#include "DDTreeNodeCondition.h"

namespace addibit {

	class PopTreeTreeNodeCondition : public TreeNodeCondition, public PopTreeMapCondition {

		public:
		PopTreeTreeNodeCondition ( const BitList & map,
										const unsigned int minCommonBits,
										const BitList & regPattern,
										const BitList & invPattern ) :
            MapCondition( map ),
			TreeNodeCondition( map, minCommonBits ),
			PopTreeMapCondition( map, regPattern, invPattern ) {}

        bool holdsOnRay( const BitList & activeSet ) const {
            return TreeNodeCondition::holdsOnRay( activeSet );
        }

        bool holdsOnFace ( const BitList & activeSetUnion ) const {
            return TreeNodeCondition::holdsOnFace( activeSetUnion );
        }

		bool holdsOnFace ( const BitList & activeSetUnion, const BitList & faceRegPattern, const BitList & faceInvPattern ) const {

			return TreeNodeCondition::holdsOnFace( activeSetUnion ) &&
					( faceRegPattern & mRegPattern ).isUnionFull( faceInvPattern & mInvPattern );
		}
	};
}

#endif // __DD_POP_TREE_PRELIMINARY_CONDITION__
