/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_RAY_REF_CONTAINER_TO_BIT_LIST_ARRAY_TRANSFORMER__
#define __DD_RAY_REF_CONTAINER_TO_BIT_LIST_ARRAY_TRANSFORMER__

#include <vector>

#include "DDBitListArray.h"
#include "DDRayRefVisitor.h"

#include "DDRayReferenceContainer.h"

namespace addibit {

    class RayRefContainerToBitListArrayTransformer : public RayRefVisitor {

        private:
        BitListArray & mArray;
        uintptr_t * & __address;
        uint_fast32_t mPosition;

        public:
        RayRefContainerToBitListArrayTransformer( BitListArray & array,
                                                  uintptr_t * & address ) :
            RayRefVisitor(),
            mArray( array ),
            __address( address ) {}

        ~RayRefContainerToBitListArrayTransformer () {}

        void onStart () {
            mPosition = 0;
        }

        void onVisit ( const RayReference & ref ) {            
            mArray.set( mPosition, ref.activeSet );
            __address[ mPosition++ ] = ref.__address;
        }
    };
}

#endif // __DD_RAY_REF_CONTAINER_TO_BIT_LIST_ARRAY_TRANSFORMER__
