
#include "DDRayRefPopulationMapping.h"
#include "DDBitSelector.h"

using namespace addibit;

void RayRefPopulationMapping::onVisit ( const RayReference & ref ) {
    unsigned int step = 0;
    unsigned int current = mRange[ step ].getInvCommonPopCnt( ref.activeSet );

    while ( current > mLimitBits /*&& step < ( mMinCommonBits - mLimitBits )*/ ) { 
        step += current - mLimitBits;
        current = mRange[ step ].getInvCommonPopCnt( ref.activeSet );
    }

    mMapping[ ref.id ] = step;
}

const BitList * RayRefPopulationMapping::getSamplesRange ( const BitSelectStrategy & strategy,
                                                           const unsigned int lbits,
                                                           const unsigned int mbits ) const {

    BitSelector selector( strategy );
    const unsigned int range = strategy.getBitCount() - mbits;
    BitList * result = new BitList[ range ];
    
    result[ 0 ] = selector.getNextNBits( mbits - lbits + 1 );

    for ( unsigned int r_index = 1; r_index < range; r_index++ ) {
        result[ r_index ] = result[ r_index - 1 ];
        result[ r_index ].setBit( selector.getNextBit() );
    }

    return result;
}   
