
#ifndef __DD_SINGLE_SET_FACE__
#define __DD_SINGLE_SET_FACE__

#include "DDSingleSetRay.h"

namespace addibit {

	class SingleSetFace {

		private:
		const SingleSetRay* mFirst;
		const SingleSetRay* mSecond;
		const BitList mActiveSet;

		public:
		SingleSetFace( const SingleSetRay* const first, const SingleSetRay* const second ) :
			mFirst( first ),
			mSecond( second ),
			mActiveSet( first->getActiveSet() & second->getActiveSet() ) {}

		const SingleSetRay* getFirst () const {
			return mFirst;
		}

		const SingleSetRay* getSecond () const {
			return mSecond;
		}

		const BitList& getActiveSet () const {
			return mActiveSet;
		}
	};
}

#endif // __DD_SINGLE_SET_FACE__
