/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_SORT_CRITERION_MATRIX_WRAPPER__
#define __DD_SORT_CRITERION_MATRIX_WRAPPER__

#include "DDSortCriterion.h"

namespace addibit {

	class SortCriterionMatrixWrapper {
	
	    private:
	    const SortCriterion & mCriterion;
	    const std::vector<CalculationVector> & mData;

		public:
		SortCriterionMatrixWrapper ( const SortCriterion & criterion,
		                             const std::vector<CalculationVector> & data ) :
		    mCriterion( criterion ),
		    mData( data ) {}
		
		/* Returns true if row[lhs] < row[rhs] and false otherwise. */
		inline bool operator() ( const unsigned int lhs, const unsigned int rhs ) const {
		    return mCriterion.ls( mData[ lhs ], mData[ rhs ] );
		}
	};
}

#endif // __DD_SORT_CRITERION_MATRIX_WRAPPER__
