/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_TERNARY_DYNAMIC_VANTAGE_POINT_VISITOR__
#define __DD_TERNARY_DYNAMIC_VANTAGE_POINT_VISITOR__

#include "DDTernaryVantagePointVisitor.h"

namespace addibit {

    class TernaryDynamicVantagePointVisitor : public TernaryVantagePointVisitor {

        public:
        TernaryDynamicVantagePointVisitor ( const unsigned int depth,
                                            const unsigned int capacity ) :
            TernaryVantagePointVisitor( depth, capacity ) {}

        void before ( const RayReferenceContainer & container ) {
            TernaryVantagePointVisitor::before( container );

            mVantagePoint = container.first().activeSet; /* Not the best solution! */

            mDistStats.resize( mVantagePoint.getPopulationCount() + 1, 0 );
        }
    };
}

#endif // __DD__TERNARY_DYNAMIC_VANTAGE_POINT_VISITOR__
