/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __DD_VER_LEAST_COMMON_BIT_FIRST_STRATEGY__
#define __DD_VER_LEAST_COMMON_BIT_FIRST_STRATEGY__

#include <vector>

#include "DDDifferentialBitStrategy.h"

namespace addibit {

    class VerLeastCommonBitFirstStrategy : public DifferentialBitStrategy {

        protected:

        double_t getProbabilityCoeff ( const uint_fast16_t /*index*/,
                                       const double_t list_probability,
                                       const double_t tree_probability ) const {

            return -list_probability * tree_probability;
        }
        
        public:
        VerLeastCommonBitFirstStrategy ( const std::vector<unsigned long> & list_container_stats,
                                         const uint64_t list_elements,
                                         const std::vector<unsigned long> & tree_container_stats,
                                         const uint64_t tree_elements,
                                         const uint_fast16_t plane ) :
            DifferentialBitStrategy( list_container_stats, list_elements, tree_container_stats, tree_elements, plane ) {} 
    };
}

#endif // __DD_VER_LEAST_COMMON_BIT_FIRST_STRATEGY__
