/*  This is part of Addibit.
    Copyright (C) 2013 Blagoy Genov

    Addibit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __DD_VERIFICATION_TREE_FACTORY__
#define __DD_VERIFICATION_TREE_FACTORY__

#include "DDTreeFactory.h"
#include "DDVerificationBitSelectionStrategyFactory.h"

namespace addibit {

    class VerificationTreeFactory : public TreeFactory {

        private:
        const RayReferenceContainer & mVerContainer;

        protected:
        const BitSelectStrategy * getBitSelectionStrategy ( const BP_Tree_BitSelectionStrategy choice ) const {
            const VerificationBitSelectionStrategyFactory factory( mPosContainer, mNegContainer, mVerContainer, mPlane );

            return factory.createBitSelectionStrategy( choice );
        }

        const RayReferenceContainer & getContainer () const {
            return mVerContainer;
        }

        public:
        VerificationTreeFactory ( const RayReferenceContainer & pcontainer,
                                  const RayReferenceContainer & ncontainer,
                                  const RayReferenceContainer & vcontainer,
                                  const uint_fast16_t plane ) :
            TreeFactory( pcontainer, ncontainer, plane ),
            mVerContainer( vcontainer ) {}
    };
}

#endif /* __DD_VERIFICATION_TREE_FACTORY__ */
